# -*- coding: utf-8 -*-
"""wise

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/14hYUgsVlc7SNw-pUpILiofc2XDh47d5w
"""



class Counter:
  def __init__(self,num):
    self.num=num
  def increment(self,num,x):
    num=num+x
    return num
  def reset(self,num):
    return num
x=int(input("Enter incrementing value:"))
number=int(input("Enter number to be incremented:"))
a=Counter(number)
print(a.increment(number,x))
print(a.reset(number))



class calculator:
  def __init__(self,a,b):
    self.a=a
    self.b=b
  def sum(self,a,b):
    return a+b
  def difference(self,a,b):
    return a-b
  def product(self,a,b):
    return a*b
  def quotient(self,a,b):
    return a/b
print("Enter two numbers")
a=int(input())
b=int(input())
c=calculator(a,b)
x=input("Enter operators:")
if x=='+':
  print(c.sum(a,b))
elif x=='-':
  print(c.difference(a,b))
elif x=='*':
  print(c.product(a,b))
elif x=='/':
  print(c.quotient(a,b))
else:
  print("enter valid operator")



class Person:
  count=0
  def __init__(self,name,age):
    self.name=name
    self.age=age
    Person.count+=1
x=Person("Vaishnavi",16)
y=Person("Bhuvana",18)
Z=Person("Pranavi",13)
print(Person.count)

class BankAccount:
  interest_rate = 0.02
  def __init__(self,account_number,balance):
    self.account_number=account_number
    self.balance=balance
  def withdraw(self,amount):
    if amount <= self.balance:
      self.balance -= amount
      print(f"Withdraw {amount} from account {self.account_number}.")
    else:
      print('Insufficient balance')
  def deposit(self,amount):
    self.balance += amount
    print(f"Deposited {amount} into account {self.account_number}")
  def get_interest_rate(cls):
    return cls.interest_rate



class Triangle:
  def __init__(self,s1,s2,s3):
    self.s1=s1
    self.s2=s2
    self.s3=s3
  def is_equilateral(self):
    return self.s1 == self.s2 == self.s3
triangle1 = Triangle(4,4,4)
print(triangle1.is_equilateral())
triangle2=Triangle(4,5,6)
print(triangle2.is_equilateral())



class Rectangle:
  def __init__(self,length,breadth):
    self.breadth=breadth
    self.length=length
  def perimeter(self):
    return 2*(self.length+self.breadth)
  def area(self):
    return self.length*self.breadth
class Square(Rectangle):
  def __init__(self,side):
    super().__init__(side,side)
rectangle=Rectangle(5,6)
print(f"AREA of rectangle is: {rectangle.area()}")
print(f"PERIMETER of rectangle is: {rectangle.perimeter()}")
square=Square(4)
print(f"AREA of square is: {square.area()}")
print(f"PERIMETER of square is: {square.perimeter()}")



class Employee:
  def __init__(self,name,salary):
    self.name = name
    self.salary=salary
  def calculate_bonus(self):
    bonus=0.1
    x=self.salary*bonus
    return self.salary+x
class Manager(Employee):
  def calculate_bonus(self):
    bonus=0.3
    y=self.salary*bonus
    return self.salary+y
class Developer(Employee):
  def calculate_bonus(self):
    bonus=0.2
    z=self.salary*bonus
    return self.salary+z
e1=Employee("steve",40000)
e2=Employee("John",60000)
e3=Employee("Natasha",50000)
print(e1.calculate_bonus())
print(e2.calculate_bonus())
print(e3.calculate_bonus())



#SALES PERSON
class Salesperson:
    def __init__(self, name):
        self.name = name
        self.record = {}
        self.value = 0.0

    def get_name(self):
        return self.name

    def buy_pro(self, product_name, market_price, quantity):
        if product_name in self.record:
            cost, current_quantity = self.record[product_name]
            updated_quantity = current_quantity + quantity
            self.record[product_name] = [cost, updated_quantity]
        else:
            self.record[product_name] = [market_price, quantity]

        self.value -= market_price * quantity

    def sell_pro(self, product_name, market_price, quantity):
        if product_name in self.record:
            cost, current_quantity = self.record[product_name]
            updated_quantity = current_quantity - quantity
            if updated_quantity > 0:
                self.record[product_name] = [cost, updated_quantity]
            else:
                del self.record[product_name]
            self.value += market_price * quantity

    def get_record(self):
        return self.record

    def get_value(self):
        return self.value
salesperson = Salesperson("Madhavi")
name = salesperson.get_name()
print("Salesperson name:", name)
salesperson.buy_pro("Product A", 10.0, 5)
salesperson.buy_pro("Product B", 20.0, 3)
salesperson.buy_pro("Product A", 10.0, 2)  
salesperson.sell_pro("Product B", 20.0, 2)
salesperson.sell_pro("Product A", 10.0, 3)  
record = salesperson.get_record()
value = salesperson.get_value()

print("Salesperson record:", record)
print("Salesperson value:", value)



# deck of cards
import random
class Card:
    def __init__(self, suit, value):
        self.suit = suit
        self.value = value

    def __repr__(self):
        return f"{self.value} of {self.suit}"

class Deck:
    def __init__(self):
        suits = ['Hearts', 'Diamonds', 'Clubs', 'Spades']
        values = ['A', '2', '3', '4', '5', '6', '7', '8', '9', '10', 'J', 'Q', 'K']
        self.cards = [Card(suit, value) for suit in suits for value in values]

    def __repr__(self):
        return f"Deck of {self.count()} cards"

    def count(self):
        return len(self.cards)

    def shuffle(self):
        if self.count() != 52:
            raise ValueError("Only full decks can be shuffled")
            random.shuffle(self.cards)

    def deal(self):
        if self.count() == 0:
            raise ValueError("All cards have been dealt")
            return self.cards.pop()
deck = Deck()
print(deck)
deck.shuffle()
print(deck)
card1 = deck.deal()
card2 = deck.deal()
print("Dealt cards:", card1, ",", card2)
print("Remaining cards:", deck)



class BankAccount:# bank account
  def __init__(self,account_number,initial_balance):
    self.account_number=account_number
    self.balance=initial_balance
  def deposit(self,amount):
    self.balance+=amount
    print(f"Deposit of Rs. {amount} successful.New balance: Rs. {self.balance}")
  def withdraw(self,amount):
    if self.balance-amount>=1000:
      self.balance-=amount
      print(f"Withdrawl of Rs. {amount} successful.New balance: Rs. {self.balance}")
    else:
      print("Insufficient balance.Transaction cancelled.")
class MinimumBalanceAccount(BankAccount):
  def __init__(self,account_number,initial_balance):
    super().__init__(account_number,initial_balance)
  def withdraw(self,amount):
    if self.balance-amount>=1000:
      super().withdraw(amount)
    else:
      print("Insufficient balance.Transaction cancelled.")
account=MinimumBalanceAccount("1234567890",30000)
account.deposit(2000)
account.withdraw(5000)